desloca=function(dados,resp,n,t){
varind=matrix(0,nrow(dados),n)
for(j in 1:n){
varind[,j]=c(rep(0,j),resp[1:(nrow(dados)-j)])
varind[seq(j,nrow(dados),t),j]=NA
if(j>1)
varind[which(is.na(varind[,(j-1)])),j]=NA}
list('novodata'=data.frame(dados,varind))}



beta0=c(-2.5,1,1)
alfa=2
beta=c(beta0,alfa)
sig=0.5
n=500
k=8
nsim=10000
count=rep(NA,nsim)
estmod1=rep(NA,length(beta0)+1)
estmod4=rep(NA,length(beta)+1)

require(glmmML)

for (l in 1:nsim){
  print(paste('Simulao =',l))
  w=rnorm(n,0,sig)
  fuma=rbinom(n,1,0.4)
  x=cbind(1,fuma,w)
  p0=exp(x%*%beta0)/(1+exp(x%*%beta0))
  y<-rep(NA,n)
  for (i in 1:n) y[i]<-rbinom(1,1,p0[i])
  dat<-data.frame(suj=1:n,tempo=rep(1,n),fuma=fuma,resp=y)

  for (j in 2:k){
    x1<-cbind(1,fuma,w,y)
    p1<-exp(x1%*%beta)/(1+exp(x1%*%beta))
    y<-rep(NA,n)
    for (i in 1:n) y[i]<-rbinom(1,1,p1[i])
    dat1<-data.frame(suj=1:n,tempo=rep(j,n),fuma=fuma,resp=y)
    dat<-rbind(dat,dat1)
  }
  
  dados<-dat
  ord=order(dados$suj,dados$tempo)
  dados<-dados[ord,]
  
  drop=desloca(dados,dados[,"resp"],1,k)
  drop=data.frame(drop)
  drop=na.omit(drop)
  names(drop)=c("suj","tempo","fuma","resp","prev1")

  mod1a<-glm(resp~fuma+prev1, family=binomial,data=drop)
  est=c(mod1a$coeff,mod1a$aic)
  estmod1=rbind(estmod1,est)

#Ajustando modelos com interceptos aleatrios

  mod4a<-glmmML(resp~fuma+prev1, cluster=suj, family=binomial,data=drop)#via Laplace
  est=c(mod4a$coeff,mod4a$sigma,mod4a$aic)
  estmod4=rbind(estmod4,est)

#  print(summary(mod1a))
#  print(summary(mod4a))

  count[l]=ifelse(mod1a$aic>mod4a$aic,1,0)

}
# percentual de vezes em que aic do mod1 > aic do mod4 
sum(count)/nsim*100

#
estmod1=estmod1[-1,]
#
estmod4=estmod4[-1,]

apply(estmod1,2,mean)
#sdmod1=apply(estmod1,2,sd)[-4]
apply(estmod4,2,mean)
#sdmod4=apply(estmod4,2,sd)[-5]

erromod1=NULL
erromod4=NULL

for (i in 1:nsim){
aux1=estmod1[i,1:3]-c(beta0[-3],alfa)
aux2=estmod4[i,1:4]-c(beta0[-3],alfa,sig)
erromod1=rbind(erromod1,aux1)
erromod4=rbind(erromod4,aux2)
}

apply(erromod1,2,mean)
apply(erromod1,2,sd)

apply(erromod4,2,mean)
apply(erromod4,2,sd)

eqmmod1=rep(NA,3)
for (i in 1:3) eqmmod1[i]=sum(erromod1[,i]**2)/length(erromod1[,i])
eqmmod4=rep(NA,4)
for (i in 1:4) eqmmod4[i]=sum(erromod4[,i]**2)/length(erromod4[,i])

eqmmod1
eqmmod4


q()
